﻿Public Class Form1

    Private Const SEND_DATA_SIZE As Integer = 300

    Private m_SendDatas As String
    Private m_strTemp As String = ""
    Private m_iTotalCount As UInteger = 0
    Private m_iFailCount As UInteger = 0
    Private m_iResponseCount As UInteger = 0

    Private m_strPortNo As String() = {"COM1", "COM2", "COM3", "COM4", "COM7"}
    Private m_strBaudRate As String() = {"115200", "57600", "38400", "19200", "14400", "9600", "4800", "2400", "1200", "600", "300", "110"}

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        smartForm1.MainForm = Me

        cmbPortNo.DataSource = m_strPortNo
        cmbPortNo.SelectItemIndex = 0

        cmbBaudRate.DataSource = m_strBaudRate
        cmbBaudRate.SelectItemIndex = 0

        smartSerialPort1.STXCode = &H2
        smartSerialPort1.ETXCode = &H3
        smartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.NONE
        smartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.HEADER
        smartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX
        smartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE
        SmartSerialPort1.FrameBufferSize = 500
        SmartSerialPort1.ReadTimeout = 1000

        lsbData.ItemAddOrder = SmartX.SmartListBox.ITEMADDORDERS.TOPADD

        m_SendDatas = GetDataGenerate(SEND_DATA_SIZE)
    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If smartSerialPort1.IsOpen = True Then
            smartSerialPort1.Close()
        End If

        smartTimer1.Stop()
    End Sub

    ' Server Message Receive 시작 버튼
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        If btnStart.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            ' SmartComboBox에서 선택한 Item의 Index로 Baud_Rate 속성값을 설정
            SmartSerialPort1.Baud_Rate = CType(Convert.ToInt32(cmbBaudRate.Text), SmartX.SmartSerialPort.BAUDRATE)

            ' SmartComboBox에서 선택한 Item의 Index로 PortNo 속성값을 설정
            If cmbPortNo.SelectItemIndex = 4 Then
                SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 3), SmartX.SmartSerialPort.COMPORTNO)
            Else
                SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 1), SmartX.SmartSerialPort.COMPORTNO)
            End If

            SmartSerialPort1.Open()

            SmartTimer1.Start()
        Else
            If SmartSerialPort1.IsOpen = True Then
                SmartSerialPort1.Close()
            End If

            SmartTimer1.Stop()
        End If
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Close()
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles smartTimer1.Tick
        ' 수신된 프레임 데이터를 표시 합니다.
        ReceiveFrameDataDisplay()
    End Sub

    Private Function GetDataGenerate(ByVal iSize As Integer) As String
        Dim retStr As String = ""
        Dim iCnt As Integer = 0

        While True
            For i As Integer = Asc("A"c) To Asc("Z"c)
                retStr += Chr(i)
                If System.Threading.Interlocked.Increment(iCnt) >= iSize Then
                    Return retStr
                End If
            Next
        End While
    End Function

    ' 수신된 프레임 단위 데이터를 표시한다.
    Private Sub ReceiveFrameDataDisplay()
        If m_iTotalCount Mod 1000 = 0 Then
            lsbData.ClearAll()
        End If

        Dim iRetCode As SmartX.SmartSerialPort.FRAMEDATAREADSTATUS = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY
        iRetCode = smartSerialPort1.ReadQueue(m_strTemp)

        m_iTotalCount += 1
        Select Case iRetCode
            Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY
            Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA
                m_iFailCount += 1
            Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.VALIDDATA
                ' Client로부터 정상 Data가 입력됨
                ' 입력된 Data가 "HNS_SMARTX"이면
                If m_strTemp = "HNS_SMARTX" Then
                    m_iResponseCount += 1
                    lsbData.AddItem("[" & m_iResponseCount.ToString() & "]" + m_strTemp)
                    ' Client로 전송
                    smartSerialPort1.WriteFrame(m_SendDatas, SmartX.SmartSerialPort.CODETYPES.UNICODE)
                Else
                    m_iFailCount += 1
                End If
        End Select
    End Sub
End Class
