﻿Public Class Form1

    Private Const SEND_DATA_SIZE As Integer = 300

    Private m_iTotalCount As UInteger = 0
    Private m_iFailCount As UInteger = 0
    Private m_iSuccessCount As UInteger = 0

    Private m_strSendCommand As String = "HNS_SMARTX"
    Private m_ReceiveOrgDatas As String
    Private m_ReceiveDatas As String

    Private m_strPortNo As String() = {"COM1", "COM2", "COM3", "COM4", "COM7"}
    Private m_strBaudRate As String() = {"115200", "57600", "38400", "19200", "14400", "9600", "4800", "2400", "1200", "600", "300", "110"}

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        smartForm1.MainForm = Me

        cmbPortNo.DataSource = m_strPortNo
        cmbPortNo.SelectItemIndex = 0

        cmbBaudRate.DataSource = m_strBaudRate
        cmbBaudRate.SelectItemIndex = 0

        SmartSerialPort1.STXCode = &H2
        SmartSerialPort1.ETXCode = &H3
        SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.NONE
        SmartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.HEADER
        SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX
        SmartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE
        SmartSerialPort1.FrameBufferSize = 5000
        SmartSerialPort1.ReadTimeout = 1000

        m_ReceiveOrgDatas = GetDataGenerate(SEND_DATA_SIZE)

        lsbError.ItemAddOrder = SmartX.SmartListBox.ITEMADDORDERS.TOPADD
    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If SmartSerialPort1.IsOpen = True Then
            SmartSerialPort1.Close()
        End If
        SmartTimer1.Stop()
    End Sub

    ' Client Message Send 시작 버튼
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        If btnStart.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            ' SmartComboBox에서 선택한 Item의 Index로 Baud_Rate 속성값을 설정
            SmartSerialPort1.Baud_Rate = CType(Convert.ToInt32(cmbBaudRate.Text), SmartX.SmartSerialPort.BAUDRATE)

            ' SmartComboBox에서 선택한 Item의 Index로 PortNo 속성값을 설정
            If cmbPortNo.SelectItemIndex = 4 Then
                SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 3), SmartX.SmartSerialPort.COMPORTNO)
            Else
                SmartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 1), SmartX.SmartSerialPort.COMPORTNO)
            End If

            SmartSerialPort1.Open()

            ' 대량의 데이터를 보내도록 명령 전송 처리
            smartSerialPort1.WriteFrame(m_strSendCommand, SmartX.SmartSerialPort.CODETYPES.UNICODE)

            smartTimer1.Start()
        Else
            If SmartSerialPort1.IsOpen = True Then
                SmartSerialPort1.Close()
            End If

            SmartTimer1.Stop()
        End If
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Close()
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmartTimer1.Tick
        ' 수신된 프레임 데이터를 표시 합니다.
        smartTimer1.Stop()
        ReceiveFrameDataDisplay()
        smartTimer1.Start()
    End Sub

    Private Sub smartSerialPort1_OnPortError(ByVal eErrorState As System.IO.Ports.SerialError) Handles SmartSerialPort1.OnPortError
        lsbError.AddItem(eErrorState.ToString())
    End Sub

    Private Function GetDataGenerate(ByVal iSize As Integer) As String
        Dim retStr As String = ""
        Dim iCnt As Integer = 0

        While True

            For i As Integer = Asc("A"c) To Asc("Z"c)
                retStr += Chr(i)
                If System.Threading.Interlocked.Increment(iCnt) >= iSize Then
                    Return retStr
                End If
            Next
        End While
    End Function

    ' 수신된 프레임 단위 데이터를 표시 한다.
    Private Sub ReceiveFrameDataDisplay()
        If m_iTotalCount Mod 1000 = 0 Then
            lsbData.ClearAll()
        End If

        Dim iRetCode As SmartX.SmartSerialPort.FRAMEDATAREADSTATUS = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY
        iRetCode = smartSerialPort1.ReadQueue(m_ReceiveDatas)

        If m_iTotalCount < 900000000 Then

            Select Case iRetCode
                Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY
                    System.Threading.Thread.Sleep(500)
                    ' Buffer Overrun Error가 발생할 경우 데이터 수신이 안됩니다.
                    ' 따라서 일정시간 대기했다가 다시 수신 데이터를 확인합니다.
                    iRetCode = smartSerialPort1.ReadQueue(m_ReceiveDatas)
                    Select Case iRetCode
                        Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY, SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA
                            m_iFailCount += 1
                        Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.VALIDDATA
                            ' Sever로부터 정상 Data가 입력됨
                            If m_ReceiveDatas = m_ReceiveOrgDatas Then
                                lsbData.AddItem(m_ReceiveDatas)
                                m_iSuccessCount += 1
                            Else
                                m_iFailCount += 1
                            End If
                    End Select

                Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA
                    m_iFailCount += 1
                Case SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.VALIDDATA
                    ' Sever로부터 정상 Data가 입력됨
                    If m_ReceiveDatas = m_ReceiveOrgDatas Then
                        lsbData.AddItem(m_ReceiveDatas)
                        m_iSuccessCount += 1
                    Else
                        m_iFailCount += 1
                    End If
            End Select

            m_iTotalCount += 1

            labTotalCount.Text = m_iTotalCount.ToString()
            labFailCount.Text = m_iFailCount.ToString()
            labSuccessCount.Text = m_iSuccessCount.ToString()

            If smartSerialPort1.IsOpen = True Then
                ' 대량의 데이터를 보내도록 명령 전송 처리
                smartSerialPort1.WriteFrame(m_strSendCommand, SmartX.SmartSerialPort.CODETYPES.UNICODE)
            End If
        End If
    End Sub
End Class
